#include "head.h"

/*  A>B,  1
    A<B,  -1
     0
*/
int comp (VStr *A, VStr *B)
{ VStr *a,*b;
        if (A==B) return 0;
        for (a=A,b=B; a||b ; a=a?a->Next:a, b=b?b->Next:b)
        {       if (a==B) return -1;
                if (b==A) return 1;
        }
        return 0;       //   
} //comp

/*  A<=C<B,  1
    B<=C<A,  -1
     0
*/
int belong (VStr *A, VStr *B, VStr *C, int vert)
{ int res1,res2;
        if (A==NULL) return 0;
        if (B==NULL) return 0;
        if (C==NULL) return 0;
        res1=comp(A,C);
        res2=comp(C,B);

        if (vert)
        {       if ((res1<=0)&&(res2<=0)) return 1;
                if ((res2>=0)&&(res1>=0)) return -1;
                return 0;
        }
        else
        {       if ((res1<=0)&&(res2<0)) return 1;
                if ((res2>=0)&&(res1>0)) return -1;
                return 0;
        }
} //belong
