class undo_b;
class undo_el;

class Edit:public View
{ public:
        int ypos,xpos;          //    
        int oldx,oldy;
        int xoffset;            //      
        int oldxoffs;           //    . 
        char Name[256];
        FILE *F;
        long Lines,Lineno;
        unsigned Curchar;
        int changed;
        int GapCnt;
        VStr *First,*Last,*Cur,*Scr;
        VStr *getlowline();

        Edit (Rect R);
        virtual ~Edit();
        int getfile (char *name);
        int loadfile (char *name);
        int loadexec (char *command);
        int storefile (char *name, VStr *A, VStr *B);
        int putfile (char *name=NULL);
        int closefile (char *name=NULL);
        void tofile (FILE *);
        virtual void Draw();
        virtual void ReDraw();
        virtual void Assign (int AX,int AY,int BX,int BY);
        void frame();
        void reframe();
        virtual unsigned Handle (unsigned &c);
        virtual int Color (int cnum);
        VStr *GetNext (VStr *P);
        VStr *GetPrev (VStr *P);
  protected:
        VStr *MarkPosY[10];
        int MarkPosX[10];
        VStr *MarkBlk;
        int vert;
        int Mbeg,Mfin;  //x- . 
        int xx,yy;

        undo_b *UndoBuf;

        int hasbak;

        int sout (int xx, int yy, char *str, int eof, int inv, int maxx=SWIDTH);
        int Search (char *text,
                unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
                        unsigned Forw, unsigned first);
        int ForwSearch (char *text,
                unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
                        unsigned first=0);
        int BackSearch (char *text,
                unsigned Case, unsigned Word, unsigned FromTop, unsigned Reg,
                        unsigned first=0);
        int SearchRepl (char *text, char *repl,
                unsigned Case, unsigned Word, unsigned FromTop,
                unsigned All, unsigned Prompt, unsigned Reg,
                unsigned first=0);
        int BrackF (char *left, char *right);
        int BrackB (char *left, char *right);
        void GotoLine (int num);
        int calcy (VStr *Lin);
        void unmark();
        void drawhalf (int offs=0);
        void insnewline (char *buf);
        void ScrollUp();
        void ScrollDown();
        virtual unsigned getsym();
        void corrxoffs();
        void delline (VStr *p);
        VStr *clearbuf (int add);
        void delbuf (VStr *A,VStr *B);
        void cutbuf (VStr *A,VStr *B,int add);
        void copybuf (VStr *A,VStr *B,int add);
        void copyline (VStr *A,int add);
        void delvbuf (VStr *A,VStr *B);
        void copyvbuf (VStr *A,VStr *B,int add);
        void cutvbuf (VStr *A,VStr *B,int add);
        void pastebuf();
        void pastevbuf();
        void scrup(int);
        void scrdn(int);
        void DelLine (int off=0);
        void InsLine (char *buf, int flag=1);
        void showchanges();
        void getline (char *buf);
        void putline (char *buf);
        void putl (char *S);
        int getUnindent (int x);
        int getLeftSpaces (char *str);
        int bsp (int x, char *str);
        void repline (VStr *old, VStr *newp, int undo=0);
        void RepTxt (VStr *L, char *txt);
        void putspec (char c);
        void putctrl (char c);
        void putnorm (char c);
        void putinv (char c);
        void setp (int flag);
        //void makebak();
        void makecopy();
        int chkdown();
        int restore ();
        int rest0(undo_el &el);
        int Format();
        friend class EWindow;
};

class EWindow:public Group
{ public:
   Rect Zoom;
   int status;
   Frame *F;
   Edit *E;
   EWindow(const Rect &R, char *name,
        int line=0, int x=0, int y=0, int xoffs=0, int hide=0,
                int *markx=NULL, int *marky=NULL);
   virtual ~EWindow();
   virtual void Assign (int AX,int AY,int BX,int BY);
   virtual void SetState (int Stat);
   virtual unsigned Handle (unsigned &c);
   void NewFrame();
   void VFrame(int flag=0);
   void EFrame(int flag=0);
};

extern int vert;
extern int trig;
extern unsigned view;
extern int zoom;
extern int wcnt;
extern int putflag;
extern Group *App;
extern char **curkeybar;
extern char **showkeybar (char **keys=curkeybar);
extern int RightMargin;
extern int LeftMargin;
extern unsigned Fmt;