#define _TERMCAP0_ "/etc/termcap"
#define _TERMCAP_  "/usr/local/lib/ve/termcap"
#define _RC_       "/usr/local/lib/ve/ve.ini"
#define _HLP_      "/usr/local/lib/ve/ve.hlp"
#define _KEYS_     "/usr/local/lib/ve/ve.key"
#define _TMP1_     "/usr/tmp/"
#define _TMP2_     "/var/tmp/"

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <setjmp.h>
#include <signal.h>
#include <sys/stat.h>

#ifdef __MSDOS__
#include <dos.h>
#include <io.h>
#ifdef _DEBUG_
#include "kbddos.h"
#else
#include "kbd.h"
#endif
#else
#define _SYSV3
#include <sys/types.h>
#include "kbd.h"
#endif

#include "vstrings.h"
#include "tty.h"
#include "dialogs.h"
#include "dlgs.h"
#include "edit.h"
#include "dir.h"
#include "line.h"
#include "block.h"
#include "undo.h"

int StrCmp (const char *s1, const char *s2);
int StrNCmp (const char *s1, const char *s2, size_t maxlen);
int StrLen (const char *s);
const char TAB='\011';
