/*
 *     
 */

#include "head.h"

KeyBar::KeyBar (const Rect &R,char **k):View(R)
{       oldkeys=NULL;
        keys=k;
        drawed=0;
        Options&=~ofSelectable;
}

unsigned KeyBar::Handle (unsigned &c)
{       switch (c)
        { case cmKeysDraw:
                drawed=0;
                break;
          case cmKeys:
                c=0;
                if (!drawed) DrawView();
                break;
        }
        return View::Handle(c);
} //KeyBar::Handle

char **KeyBar::SetKeys (char **k)
{       oldkeys=keys;
        keys=k;
        DrawView();
        return oldkeys;
} //KeyBar::SetKeys

void KeyBar::ReDraw()
{ if (keys!=oldkeys) Draw(); }

void KeyBar::Draw()
{ int n, pos;
  char *p;
  char t[80];


        int spaces=(SWIDTH-70)+1;
        int sp=spaces%10;

        drawed=1;
        curxy(A.X,A.Y);
        pos=0;
        if (keys)
        for (n=0; n<10; n++)
        {       p=t;
                if (n>0)
                {       for (int i=0; i<spaces/10; i++)
                                *p++=' ';
                        if (n<sp+1) *p++=' ';
                }
                sprintf(p,"%1d",n+1);
                pos+=strlen(t);
                if (pos>SWIDTH)
                {  if (pos-SWIDTH>strlen(t)) break;
                   t[strlen(t)-(pos-SWIDTH)]=0;
                }
                Color(14);
                fprintf(stdout,"%s",t);
                Color(1);

                if (keys[n]) p=keys[n];
                else p=" ";
                if (n==9)
                        sprintf(t,"%-5s",p);
                else    sprintf(t,"%-6s",p);
                pos+=strlen(t);
                if (pos>SWIDTH)
                {  if (pos-SWIDTH>strlen(t)) break;
                   t[strlen(t)-(pos-SWIDTH)]=0;
                }
                fprintf(stdout,"%s",t);
        }
        clreol();
        Color(0);
} //KeyBar::Draw

