/*
 *   
 */

#include "head.h"

char *_normal,*_special,*_head,
     *_highlight,*_sel,*_control,*_error,*_std,
     *_dialog, *_button, *_virgin, *_line,
     *_cline, *_sline, *_number, *_cursor,
     *_is, *_rs, *_xtitle;
     
char *_rusmap,*_rus,*_lat;
int _isrus;

char *_bell;
char *_curpos,*_clreol,*_clrscr,
     *_iline,*_dline,*_scrup,*_scra;
char *_scrdn="\n";
char _graph0[] = "+-+-||--";
char *_graph;
char *_graph_on="",*_graph_off="";
char *_fill="";

int SWIDTH;             //  -1
int SHIGHT;             //  -1

#if __MSDOS__
unsigned char MINRUS='';
inline int isrus(unsigned char ch)
{ return (128<=ch)&&(ch<=175)||(224<=ch)&&(ch<=239); }
#else
unsigned char MINRUS=0300;
inline int isrus(unsigned char ch)
{ return (0300<=ch)&&(ch<=0377); }
#endif

//  ?
inline int islat(unsigned char ch)
{ return (040<=ch)&&(ch<=127); }

//      
void pch (char c)
{ unsigned ch=(unsigned char)c;
    if ((ch>=MINRUS)&&(ch-MINRUS<64)&&(_rusmap))
        ch=(unsigned char)RusMap[ch-MINRUS];
    if (isrus(ch)&&(_rus)) prtc(_rus);
    else if (islat(ch)&&(_lat)) prtc(_lat);
    putc(ch,stdout);
} //pch

//  
int prt (char *str)
{       if (str==NULL) return 0;
        while (*str) pch(*str++);
        return 1;
} //prt

//    len
int prtn (char *str, int len)
{ char *p;
  int i;
        if (str==NULL) return 0;
        for (p=str,i=0; *p && (i<len); p++, i++)
                pch(*p);
        if (i>=len) return 1;
        for (; i<len; i++)
                pch(' ');
        return 0;
} //prtn

//    ( )
int prtc (char *format, int y, int x)
{  char *p;
   int incr=0;
   int arg[2];
   int i,num,mult;
        if (format==NULL) return 0;
        arg[0]=y; arg[1]=x;
        p=format; num=0; mult=0;
        while (isdigit(*p))
        {       num=num*10+(*p-'0');
                p++;
        }
        if (*p=='*')
        {       mult=1;
                p++;
        }
        for (i=0; *p && (i<=2); p++)
         if (*p!='%') pch(*p);
         else
         {      switch (*++p)
                { case 'd':
                        fprintf(stdout,"%d",arg[i++]+incr);
                        break;
                  case '2':
                        fprintf(stdout,"%02d",arg[i++]+incr);
                        break;
                  case '3':
                        fprintf(stdout,"%03d",arg[i++]+incr);
                        break;
                  case '.':
                        fprintf(stdout,"%c",arg[i++]+incr);
                        break;
                  case 'r':
                        arg[0]=x; arg[1]=y;
                        break;
                  case 'i':
                        incr=1;
                        break;
                  case '+':
                        fprintf(stdout,"%c",*++p+arg[i++]+incr);
                        break;
                  case '<':
                        ++p;
                        if (arg[i]<*p++)
                          fprintf(stdout,"%c",*p+arg[i++]+incr);
                        break;
                  case 'n':
                        x ^= 0140;
                        y ^= 0140;
                        break;
                  case '%':
                        pch('%');
                        break;
                  default:
                        pch(*p);
                }
         }
         /*
         if (speed>=minspeed)   // 
         {      if (mult) num*=y;
                num=(long)speed/8*num/1000;
                for (i=0; i<num; i++)
                        pch(*_fill);
         }
         */
         return 1;
} //prtc

int initscr()	//  
{ return prtc(_is,0,0); }

int resetscr()	//  
{ return prtc(_rs,0,0); }

void xtitle (char *str)
{	if (str==NULL) str="xterm";
	if (_xtitle) printf(_xtitle,str);
}

int clreol()    //      
{ return prtc(_clreol,0,0); }

int clrscr()    //  
{ return prtc(_clrscr,0,0); }

int iline()     //  
{ return prtc(_iline,0,0); }

int dline()     //  
{ return prtc(_dline,0,0); }

//  
int Color (int cnum)
{ static int ColNum=0;
  int res=0;
        if (ColNum==cnum) return 1;
        ColNum=cnum;
        switch (cnum)
        { case 1:
                res=prtc(_head); break;
          case 2:
                res=prtc(_special); break;
          case 3:
                res=prtc(_control); break;
          case 4:
                res=prtc(_highlight); break;
          case 5:
                res=prtc(_sel); break;
          case 6:
                res=prtc(_error); break;
          case 7:
                res=prtc(_normal); break;
          case 8:
                res=prtc(_dialog); break;
          case 9:
                res=prtc(_button); break;
          case 10:
                res=prtc(_virgin); break;
          case 11:
                res=prtc(_line); break;
          case 12:
                res=prtc(_cline); break;
          case 13:
                res=prtc(_sline); break;
          case 14:
                res=prtc(_number); break;
          case 15:
                res=prtc(_cursor); break;
          default:
                ColNum=0;
                res=prtc(_std); break;
        }
        return res;
} //Color
