#define MaxResCount 4000        /*.   */
#define MaxCount    8000        /*.   */

#ifdef __MSDOS__
#define LFsize 2
#else
#define LFsize 1
#endif

class VStr;

void DisposeVStr (VStr*);

struct VPtr
{ VPtr *Prev,*Next;       //    
  VStr *Owner;            // 
  long Pos;               //  
  char S[1];                //
};

struct VStr
{
  VPtr *Ptr;
  VStr *Prev, *Next;

  unsigned FNum:4;
  unsigned Modified:1;
  unsigned Resident:1;
  unsigned isGap:1;
};

VStr *GetNext(VStr*);
VStr *GetPrev(VStr*);
FILE *FPtr(VStr*);                         //  

void PutVStr (FILE *Stream, char *S);
int IsEmpty(VStr*);
long GetPos(VStr*);

struct GapStr: VStr
{ long A,B;
  GapStr (FILE *Stream);
};

void BackRead (FILE *f, char *S);
char *GetVStr (VStr *P);
VStr *SetVStr (FILE *Stream, long P, char *S=NULL);
VStr *CreateVStr (FILE *Stream);
VStr *ReadVStr (FILE *Stream);
VStr *NewVStr (char *S="");
void DisposePVStr (VStr *P);
void ClearVStr (VStr *P);
int AllResident();
void FreeVMemory();
void CleanVStrings();

extern FILE *Swap;
extern char SwapName[256];

