/*
 * 
 */

#include "head.h"
#ifdef __MSDOS__
#include <dir.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif

extern unsigned color;
extern void check_color();
extern void gettermcap();

class ErrDialog:public Dialog
{ public:
   ErrDialog (const Rect &R, char *txt="", int shadow=0):Dialog(R,txt,shadow){};
   virtual int Color (int cnum);
};

int ErrDialog::Color (int cnum)
{       switch (cnum)
        { case 9:  return ::Color(4);
          case 8:  return ::Color(6);
          default: return ::Color(cnum/*0*/);
        }
} //ErrDialog::Color

char *dlgkeys[]={"","","","","","","","","","Quit"};
unsigned ExitDlg (char *name)
{ char str[40];
  ErrDialog D(Rect(50,5),"Edit",1);
        strcpy(str,"\"");
        strncat(str,name,sizeof(str)-6);
        if (StrLen(name)>StrLen(str)+2) strcat(str,"...");
        strcat(str,"\"");
        int ll=(D.Size().X-StrLen(str)-1)/2;

        D.Insert(new StaticText(Rect(8,1,48,2),"You've made changes in the file"));
        D.Insert(new StaticText(Rect(ll,2,ll+StrLen(str)+1,3),str));
        D.Insert(new Button(Rect(4,3,12,4),"Save", 'S',cmYes,sfDefault));
        D.Insert(new Button(Rect(13,3,27,4),"Don't save",'D',cmNo));
        D.Insert(new Button(Rect(28,3,49,4),"Continue editing", 'C',cmCancel));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
        unsigned res=D.Exec();
        showkeybar(p);
        return res;
} // ExitDlg

void SaveMsg()
{ Dialog D(Rect(20,3),"Edit",1);
        D.Insert(new StaticText(Rect(2,1,18,2),"Saving the file"));
        D.DrawView();
        fflush(stdout);
} //SaveMsg

void WaitMsg ()
{ Dialog D(Rect(10,3),"",1);
        D.Insert(new StaticText(Rect(4,1,9,2),"Wait"));
        D.DrawView();
        fflush(stdout);
} //WaitDlg

unsigned Case,Words,FromTop,Reg,Back;
unsigned All=1,Prompt=1,replace;
char Pattern[80];
char Repl[80];

char buf[80];
void SearchBuild (Dialog *D)
{       D->Assign(Rect(60,6));
        D->Center();
        int middle=(D->B.X-D->A.X)/2;
        int right=(D->B.X-D->A.X);
        D->Insert(new InputLine(Rect(2,1,right-2,2),"Find: ",'F',buf,sizeof(buf)));
        D->Insert(new CheckBox(Rect(2,2,middle,3),"Case sensitive",'C',&Case));
        D->Insert(new CheckBox(Rect(2,3,middle,4),"Whole words",'W',&Words));
        D->Insert(new CheckBox(Rect(2,4,middle,5),"Back",'B',&Back));
        D->Insert(new CheckBox(Rect(middle+2,2,right-2,3),"from Top",'T',&FromTop));
#ifdef REGEXP
        D->Insert(new CheckBox(Rect(middle+2,3,right-2,4),"Regular expressions",'R',&Reg));
#endif
        D->SelectNext();
} //SearchBuild

unsigned SearchDlg()
{ unsigned res;
  Dialog D(Rect(60,6),"Search",1);
        strncpy(buf,Pattern,sizeof(buf));
        SearchBuild(&D);
        D.Build=SearchBuild;
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        if (res==cmOK)
        {       strncpy(Pattern,buf,sizeof(Pattern));
                replace=0;
        }
        return res;
} //SearchDlg

void SearchingMsg()
{ char str[18];
  Dialog D(Rect(20,4),"Edit",1);
        strcpy(str,"\"");
        strncat(str,Pattern,sizeof(str)-6);
        strcat(str,"\"");
        if (StrLen(Pattern)>StrLen(str)+2)
        strcat(str,"...");
        int ll=(D.Size().X-StrLen(str))/2;
        D.Insert(new StaticText(Rect(2,1,18,2),"Searching for"));
        D.Insert(new StaticText(Rect(ll,2,ll+StrLen(str)+1,3),str));
        D.DrawView();
        fflush(stdout);
} //SearchingMsg

int cstrlen (char *s)
{ int i=0;
        if (s)
            for (i=0; *s; i++, s++)
                if ((unsigned)(*s)<' ') i++;
        return i;
} //cstrlen

void NotFoundMsg()
{ char str[28];
  Rect R(30,5);
  R.A.Y+=4; R.B.Y+=4;
  ErrDialog D(R,"Edit",1);
        strcpy(str,"\"");
        strncat(str,Pattern,sizeof(str)-6);
        strcat(str,"\"");
        if (StrLen(Pattern)>StrLen(str)+2)
        strcat(str,"...");
        int ll=(D.Size().X-cstrlen(str)-1)/2;

        D.Insert(new StaticText(Rect(2,1,28,2),"Could not find the string"));
        D.Insert(new StaticText(Rect(ll,2,ll+cstrlen(str)+1,3),str));
        D.Insert(new Button(Rect(12,3,16,4)," OK ", 'K',cmOK,sfDefault));
        char **p=showkeybar(dlgkeys);
        D.Exec();
        showkeybar(p);
} //NotFoundMsg

unsigned NumDlg (int &num)
{ static char buf[7];
  unsigned res;
  Dialog D(Rect(20,3),"Go to line",1);
        //buf[0]=0;
        D.Insert(new InputLine(Rect(2,1,18,2),"Number: ",'N',buf,6));
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        num=atoi(buf);
        return res;
} //NumDlg

unsigned RepDlg (int &num)
{ static char buf[7];
  unsigned res;
  Dialog D(Rect(20,3),"Repeat macro",1);
        //buf[0]=0;
        D.Insert(new InputLine(Rect(2,1,18,2),"Number: ",'N',buf,6));
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        num=atoi(buf);
        return res;
} //RepDlg

unsigned EdDlg ()
{ unsigned res;
  Dialog D(Rect(30,4),"Edit",1);
        D.Insert(new StaticText(Rect(5,1,27,2),"Do you want to edit?"));
        D.Insert(new Button(Rect(7,2,13,3)," Yes ", 'Y',cmYes,sfDefault));
        D.Insert(new Button(Rect(16,2,22,3)," No ", 'N',cmNo));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        return res;
} //EdDlg

unsigned WriteErr (char *name)
{ char str[18];
  Rect R(35,5);
  R.A.Y+=4; R.B.Y+=4;
  ErrDialog D(R,"Edit",1);
        strcpy(str,"\"");
        strncat(str,name,sizeof(str)-6);
        if (StrLen(name)>StrLen(str)+2) strcat(str,"...");
        strcat(str,"\"");
        int ll=(D.Size().X-StrLen(str)-1)/2;

        D.Insert(new StaticText(Rect(7,1,R.B.X-2,2),"Can't write the file"));
        D.Insert(new StaticText(Rect(ll,2,ll+StrLen(str)+1,3),str));

        D.Insert(new Button(Rect(5,3,15,4),"Save as...", 'S',cmYes,sfDefault));
        D.Insert(new Button(Rect(20,3,30,4),"Cancel", 'C',cmCancel));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
        unsigned res=D.Exec();
        showkeybar(p);
        return res;
} //WriteErr

void OpenErr (char *name)
{ char str[18];
  Rect R(22,5);
  R.A.Y+=4; R.B.Y+=4;
  ErrDialog D(R,"Edit",1);
        strcpy(str,"\"");
        strncat(str,name,sizeof(str)-6);
        if (StrLen(name)>StrLen(str)+2) strcat(str,"...");
        strcat(str,"\"");
        int ll=(D.Size().X-StrLen(str)-1)/2;

        D.Insert(new StaticText(Rect(2,1,R.B.X-2,2),"Can't open the file"));
        D.Insert(new StaticText(Rect(ll,2,ll+StrLen(str)+1,3),str));
        D.Insert(new Button(Rect(9,3,13,4)," OK ", 'K',cmOK,sfDefault));
        char **p=showkeybar(dlgkeys);
        D.Exec();
        showkeybar(p);
} //OpenErr

unsigned NoFile (char *name)
{ char str[18];
  Rect R(28,5);
  R.A.Y+=4; R.B.Y+=4;
  ErrDialog D(R,"Edit",1);
        strcpy(str,"\"");
        strncat(str,name,sizeof(str)-6);
        if (StrLen(name)>StrLen(str)+2) strcat(str,"...");
        strcat(str,"\"");
        int ll=(D.Size().X-StrLen(str)-1)/2;

        D.Insert(new StaticText(Rect(2,1,R.B.X-2,2),"File not found, create it?"));
        D.Insert(new StaticText(Rect(ll,2,ll+StrLen(str)+1,3),str));
        D.Insert(new Button(Rect(6,3,11,4)," Yes ", 'Y',cmYes,sfDefault));
        D.Insert(new Button(Rect(18,3,22,4)," No ", 'N',cmNo));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
        unsigned res=D.Exec();
        showkeybar(p);
        return res;
} //NoFile

unsigned GetName (char *name)
{ char buf[80];
  unsigned res;
  Dialog D(Rect(60,3),"Save as",1);
        strncpy(buf,name,sizeof(buf));
        D.Insert(new InputLine(Rect(2,1,58,2),"Name: ",'N',buf,sizeof(buf)));
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        if (res==cmOK) strncpy(name,buf,sizeof(buf));
        return res;
} //GetName

unsigned GetFName (char *name)
{ char buf[80];
  unsigned res;
  Dialog D(Rect(60,3),"Write file",1);
        strncpy(buf,name,sizeof(buf));
        D.Insert(new InputLine(Rect(2,1,58,2),"Name: ",'N',buf,sizeof(buf)));
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        if (res==cmOK) strncpy(name,buf,sizeof(buf));
        return res;
} //GetFName

unsigned GetCommand (char *command)
{ char buf[80];
  unsigned res;
  Dialog D(Rect(70,3),"Command",1);
        strncpy(buf,command,sizeof(buf));
        D.Insert(new InputLine(Rect(2,1,68,2),"",'C',buf,sizeof(buf)));
        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        if (res==cmOK) strncpy(command,buf,sizeof(buf));
        return res;
} //GetCommand

char rbuf[80];
void SRepBuild (Dialog *D)
{       D->Assign(Rect(60,8));
        D->Center();
        int middle=(D->B.X-D->A.X)/2;
        int right=(D->B.X-D->A.X);
        D->Insert(new InputLine(Rect(2,1,right-2,2),"Find    : ",'F',buf,sizeof(buf)));
        D->Insert(new InputLine(Rect(2,3,right-2,4),"New text: ",'N',rbuf,sizeof(rbuf)));
        D->Insert(new CheckBox(Rect(4,4,middle,5),"All",'A',&All));
        D->Insert(new CheckBox(Rect(4,5,middle,6),"Prompt",'P',&Prompt));
        D->Insert(new CheckBox(Rect(4,6,middle,7),"Case sensitive",'C',&Case));
        D->Insert(new CheckBox(Rect(middle+2,4,right,5),"Whole words",'W',&Words));
        D->Insert(new CheckBox(Rect(middle+2,5,right,6),"from Top",'T',&FromTop));
#ifdef REGEXP
        D->Insert(new CheckBox(Rect(middle+2,6,right,7),"Regular expressions",'R',&Reg));
#endif
        D->SelectNext();
} //SRepBuild


unsigned SRepDlg ()
{ //char buf[80],rbuf[80];

  unsigned res;
  Dialog D(Rect(60,8),"Replace",1);
  strncpy(buf,Pattern,sizeof(buf));
  strncpy(rbuf,Repl,sizeof(rbuf));
  SRepBuild(&D);
  D.Build=SRepBuild;

        char **p=showkeybar(dlgkeys);
        res=D.Exec();
        showkeybar(p);
        if (buf[0]==0) return cmCancel;
        if (res==cmOK)
        { strncpy(Pattern,buf,sizeof(Pattern));
          strncpy(Repl,rbuf,sizeof(Repl));
          replace=1;
        }
        return res;
} //SRepDlg

class RepDialog:public Dialog
{ int xx,yy;
 public:
   RepDialog (Rect &R, char *txt, int x, int y):Dialog(R,txt,1)
   { xx=x; yy=y;};
 protected:
   virtual unsigned getsym();
};

unsigned RepDialog::getsym()
{       ::curxy(xx,yy);
        return Dialog::getsym();
} //RepDialog::getsym

unsigned RepDlg (int x, int y)
{       Rect R(40,5);
        if (y>SHIGHT/2)
        {       R.A.Y-=SHIGHT/4;
                R.B.Y-=SHIGHT/4;
        }
        else
        {       R.A.Y+=SHIGHT/4;
                R.B.Y+=SHIGHT/4;
        }
        RepDialog D(R,"Replace prompt",x,y);

        D.Insert(new StaticText(Rect(7,1,33,2),"Replace this occurence?"));
        D.Insert(new Button(Rect(5,3,12,4),"Yes", 'Y',cmYes,sfDefault));
        D.Insert(new Button(Rect(12,3,19,4),"No",'N',cmNo));
        D.Insert(new Button(Rect(19,3,26,4),"All",'A',cmOK));
        D.Insert(new Button(Rect(26,3,36,4)," Cancel", 'C',cmCancel));
        D.SelectNext();
        char **p=showkeybar(dlgkeys);
        unsigned res=D.Exec();
        showkeybar(p);
        return res;
} //RepDlg

unsigned Bak,AutoIndent,Unindent,printable,ThruTabs=1,Save=0;

#ifdef __MSDOS__
 static char rmode[]="rb";
 static char wmode[]="wb";
#else
 static char rmode[]="r";
 static char wmode[]="w";
#endif

void scfg (FILE *f)
{	fprintf(f,"Color = %d\n",color);
	fprintf(f,"Back = %d\n",Bak);
	fprintf(f,"Auto_indent = %d\n",AutoIndent);
	fprintf(f,"Unindent = %d\n",Unindent);
	fprintf(f,"Thru_tabs = %d\n",ThruTabs);
	fprintf(f,"Save = %d\n",Save);
	fprintf(f,"Group_undo = %d\n",group_undo);
	fprintf(f,"Max_undo = %d\n",MAXUNDO);
	fprintf(f,"Format = %d\n",Fmt);
	fprintf(f,"Left_margin = %d\n",LeftMargin);
	fprintf(f,"Right_margin = %d\n",RightMargin);
} //scfg

void savecfg()
{ FILE *f;
  char filename[256];
	gethome(filename);
	strcat(filename,".ve.ini");
	f=fopen(filename,wmode);
	if (f==NULL) return;
	scfg(f);
	fclose(f);
} //savecfg

int getopt (FILE *f, char *name, char *str)
{ char s[80], *p;
	if (str) strcpy(str,"");
	if (name) strcpy(str,"");

	if (!fgets(s,80,f)) return 0;
	if (s[0]=='#') return 1;
	p=strchr(s,'#');
	if (p) *p=0;
	p=s+strlen(s)-1;
	while (p>s && (*p==' '||*p=='\t'||*p=='\n')) *p--=0;
	p=strchr(s,'=');
	if (p)
	{   *p++=0;
	    while (*p==' '||*p=='\t') p++;
	    if (str) strcpy(str,p);
	}
	if (strlen(s)>0)
	{   p=s+strlen(s)-1;
	    while (p>s && (*p==' '||*p=='\t')) p--;
	    p++; *p=0;
	}
	if (name) strcpy(name,s);
	return 1;
} //getopt

int lcfg (char *s, char *ss)
{	if (!strcmp(s,"Back")) sscanf(ss,"%d",&Bak);
	else if (!strcmp(s,"Auto_indent")) sscanf(ss,"%d",&AutoIndent);
	else if (!strcmp(s,"Unindent")) sscanf(ss,"%d",&Unindent);
	else if (!strcmp(s,"Thru_tabs")) sscanf(ss,"%d",&ThruTabs);
	else if (!strcmp(s,"Save")) sscanf(ss,"%d",&Save);
	else if (!strcmp(s,"Group_undo")) sscanf(ss,"%d",&group_undo);
	else if (!strcmp(s,"Max_undo")) sscanf(ss,"%d",&MAXUNDO);
	else if (!strcmp(s,"Format")) sscanf(ss,"%d",&Fmt);
	else if (!strcmp(s,"Right_margin")) sscanf(ss,"%d",&RightMargin);
	else if (!strcmp(s,"Left_margin")) sscanf(ss,"%d",&LeftMargin);
	else if (!strcmp(s,"Color")) sscanf(ss,"%d",&color);
	else return 0;
	return 1;
} //lcfg

void loadcfg()
{ FILE *f;
  char filename[256];
  char s[80], ss[80], *p, *pp;

	gethome(filename);
	strcat(filename,".ve.ini");
	f=fopen(filename,rmode);
	if (f==NULL)
	{   f=fopen(_RC_,rmode);
	    if (f==NULL) return;
	}
	while (!feof(f))
	{   if (!getopt(f,s,ss)) break;
	    lcfg(s,ss);
	}

	if (MAXUNDO<10) MAXUNDO=10;
	if (MAXUNDO==0177777) MAXUNDO-=2;

	fclose(f);
} //loadcfg

unsigned Config()
{ unsigned res,t;
  unsigned col,bak,autoindent,unindent,thrutabs,save,fmt,group;
  char bufundo[6],right[6],left[6];
  Dialog D(Rect(40,17),"Configuration",1);

     D.Insert(new CheckBox (Rect(6,2,32,3),      "Color display)",'Y',&col));
     D.Insert(new CheckBox (Rect(6,3,32,4),      "Cr)eate .b files",'R',&bak));
     D.Insert(new CheckBox (Rect(6,4,32,5),      "A)uto indent",'A',&autoindent));
     D.Insert(new CheckBox (Rect(6,5,32,6),      "F)ormatting",'F',&fmt));
     D.Insert(new InputLine(Rect(6,6,32,7),  "    Righ)t margin: ",'H',right,sizeof(right)));
     D.Insert(new InputLine(Rect(6,7,32,8),  "    In)dent:       ",'N',left,sizeof(left)));
     D.Insert(new CheckBox (Rect(6,8,32,9),      "B)ackspace unindents ",'B',&unindent));
     D.Insert(new CheckBox (Rect(6,9,32,10),     "Cursor through t)abs ",'T',&thrutabs));
     D.Insert(new CheckBox (Rect(6,10,32,11),    "Save desktop)",'P',&save));
     D.Insert(new CheckBox (Rect(6,11,32,12),    "Group undo",'G',&group));
     D.Insert(new InputLine(Rect(6,12,32,13),"    U)ndo buf size:",'U',bufundo,sizeof(bufundo)));

     D.Insert(new Button(Rect( 3,14, 9,15),"[OK]",'O',cmOK,sfDefault));
     D.Insert(new Button(Rect( 9,14,17,15),"[Sa(v)e]", 'V',cmYes));
     D.Insert(new Button(Rect(17,14,28,15),"[Default]",'D',cmNo));
     D.Insert(new Button(Rect(28,14,38,15),"[Cancel]", 'C',cmCancel));

        D.SelectNext();
        char **p=showkeybar(dlgkeys);
ree:    col=color; bak=Bak; autoindent=AutoIndent; unindent=Unindent;
        thrutabs=ThruTabs; save=Save; fmt=Fmt;
        group=group_undo;
        sprintf(bufundo, "%-1u",MAXUNDO);
        sprintf(right, "%-1u",RightMargin);
        sprintf(left, "%-1u",LeftMargin);
        res=D.Exec();
        switch (res)
        { case cmOK:
          case cmYes:
                Bak=bak;
                AutoIndent=autoindent;
                Unindent=unindent;
                ThruTabs=thrutabs;
                Save=save;
                Fmt=fmt;
                group_undo=group;
                RightMargin=atoi(right);
                if (RightMargin<0) RightMargin=0;
                LeftMargin=atoi(left);
                if (LeftMargin<0) LeftMargin=0;
                if (LeftMargin>=RightMargin) LeftMargin=0;
                MAXUNDO=atoi(bufundo);
                if (MAXUNDO<10) MAXUNDO=10;
                if (MAXUNDO==0177777) MAXUNDO-=2;
		if (col!=color)
		{	color=col;
			check_color();
			App->Handle(t=_Refresh);
		}
                if (res==cmYes) savecfg();
                break;
          case cmNo:
                loadcfg();
                goto ree;
        }
        showkeybar(p);
        return res;
} //Config

class HDialog:public Dialog
{ public:
   virtual unsigned Handle (unsigned &c);
   HDialog (const Rect &R):Dialog(R,"Help",0){};
  protected:
   virtual void Draw();
};

unsigned HDialog::Handle (unsigned &c)
{       if ((c==_Enter)||(c==' ')||(c==_Down)||(c==_PgDn)) return cmYes;
        if ((c==_Up)||(c==_PgUp)) return cmNo;
        if ((c!=_F10)&&(c!=_Esc)&&(c!=_Refresh)) c=0;
        return Dialog::Handle(c);
}

void HDialog::Draw()
{ static char txt[]="Press Esc to quit or Enter to continue";
        Dialog::Draw();
        Color(1);
        curxy((A.X+B.X-sizeof(txt))/2,B.Y-1);
        prt(txt);
}

void Help()
{ int i,n,pnum;
  FILE *f;
  static long pages[10];
  unsigned res;
#ifdef __MSDOS__
        {       char path[256];
                gethome(path);
                strcat(path,"ve.hlp");
                f=fopen(path,"r");
        }
#else
        f=fopen(_HLP_,"r");
#endif
 char Txt[2048];
        if (f==NULL) return;
        HDialog D(Rect(SWIDTH-4,SHIGHT-2));
        Point P=D.Size();
        D.Insert(new StaticText(Rect(2,1,P.X,P.Y),Txt));
        char **p=showkeybar(dlgkeys);
        for (pnum=0;;)
        {       if ((pages[pnum]==0)&&(pnum>0))
                        pages[pnum]=ftell(f);
                else    fseek(f,pages[pnum],0);
                for (i=n=0; (i<(int)sizeof(Txt)-1) && (n<P.Y-2); i++)
                {       int c=fgetc(f);
                        if (c<0) break;
                        if (c=='\n') n++;
                        Txt[i]=c;
                }
                Txt[i]=0;
                D.drawed=0;
                res=D.Exec();
                if (res==cmYes)
                {       if (feof(f)) break;
                        pnum++;
                }
                else if (res==cmNo)
                {       if (pnum>0) pnum--;
                }
                else if (cmCancel==res) break;
        }
        showkeybar(p);
        fclose(f);
} //Help

void gethome (char *s)
{
#ifdef __MSDOS__
  char path[MAXPATH];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
        fnsplit(_argv[0],path,dir,file,ext);
        strcat(path,dir);
        strcpy(s,path);
#else
        strcpy(s,getenv("HOME"));
        strcat(s,"/");
#endif
} //gethome

FILE *StatFile;
char StatName[256];

int createtmp()
{ char *name;
        if (StatName[0]!=0)
        {       StatFile=fopen(StatName,wmode);
                return (StatFile!=NULL);
        }
#ifdef __MSDOS__
  char path[256];
        gethome(path);
        if ((name=tempnam(path,"vex")) == NULL) return 0;
#else
        if ((name=tempnam(_TMP1_,"vex"))==NULL)
          if ((name=tempnam(_TMP2_,"vex"))==NULL) return 0;
#endif
        StatFile=fopen(name,wmode);
        if (StatFile) strcpy(StatName,name);
        free(name);
        return (StatFile!=NULL);
} //createtmp

#ifdef __MSDOS__
static struct ffblk ff;
int ffirst (char *path, char *name)
{  char pattern[256];
   strcpy(pattern,path);
   if (pattern[strlen(pattern)-1]!='\\')
        strcat(pattern,"\\");
   strcat(pattern,"vex*.$$$");
   int done=findfirst(pattern,&ff,0);
   if (!done) strcpy(name,ff.ff_name);
   return done;
}

int ffnext(char *name)
{  int done=findnext(&ff);
   if (!done) strcpy(name,ff.ff_name);
   return done;
}

void ffclose()
{}
#else
static DIR *dir;

int ffnext(char *name)
{ struct dirent *d;
        d=readdir(dir);
        if (d==NULL) return 1;
        strcpy(name,d->d_name);
        return 0;
}

int ffirst (char *path, char *name)
{
        dir=opendir(path);
        if (dir==NULL) return 1;
        return ffnext(name);
}

void ffclose()
{       if (dir) closedir(dir);
}
#endif

static unsigned t;
void sloop (View *p, int i)
{ p->Handle(t=cmSaveStat); }

void SaveStat()
{ char curpath[256];
  //cfg config;
        if (!Save) return;
        if (createtmp()==0) return;
        getcwd(curpath, sizeof(curpath));
        fprintf(StatFile,"Path = %s\n",curpath);
        fprintf(StatFile,"Pattern = \"%s\"\n",Pattern);
        fprintf(StatFile,"Zoom = %d\n",zoom);
        scfg(StatFile);
        fprintf(StatFile,"Macro =");
        for (int i=0; i<=MAXMACRO; i++)
        {       fprintf(StatFile," %d",macro[i]);
                if (macro[i]==0) break;
        }
        fprintf(StatFile,"\n");

        App->Handle(t=cmSaveStat);  //App->ForEach(&sloop);
        fclose(StatFile);
} //SaveStat

struct { int Lineno;
         int xpos;
         int ypos;
         int xoffset;
         int markx[10], marky[10];
         char Name[80];
       } stats[12];

void getl (char *s, FILE *f)
{ int c,i;
        i=0;
        while (!feof(f))
        {       c=getc(f);
                i++;
                if (c<=0) break;
                if (i>=254) break;
                *s++=c;
        }
        *s=0;
} //getl

void StatOpen (char *path)
{ char fpath[512];
  char curpath[512];
  char s[80], ss[80];
  char name[80];
  int done;
        getcwd(curpath, sizeof(curpath));
        for (done=ffirst(path,name); !done; done=ffnext(name))
        {       if ((tolower(name[0])!='v')||(tolower(name[1])!='e')) continue;
                char fname[256];
#ifdef __MSDOS__
                if (path[strlen(path)-1]!='\\')
                strcat(path,"\\");
#endif
                strcpy(fname,path);
                strcat(fname,name);
#ifndef __MSDOS__
                struct stat sb;
                stat(fname,&sb);
                if (sb.st_uid!=getuid()) continue;
#endif
                StatFile=fopen(fname,rmode);
                if (StatFile==NULL) continue;
                getopt(StatFile,s,fpath);
                if (strcmp(s,"Path")) continue;
                if (StrCmp(fpath,curpath))
                {       fclose(StatFile);
                        StatFile=NULL;
                        continue;
                }
                strcpy(StatName,fname);
                getopt(StatFile,s,ss);
                if (!strcmp(s,"Pattern"))
                {       char *p=ss;
                        if (*p=='\"') p++;
                        if (*p && p[strlen(p)-1]=='\"') p[strlen(p)-1]=0;
                        strcpy(Pattern,p);
                }
                break;
        }
        ffclose();
} //StatOpen

void StOpen()
{
#ifdef __MSDOS__
  char path[256];
        gethome(path);
        StatOpen(path);
        if (StatFile==NULL) StatOpen(getenv("TMP"));
#else
        StatOpen(_TMP1_);
        if (StatFile==NULL) StatOpen(_TMP2_);
#endif
}

int RestoreStat()
{ //cfg config;
  int cnt,i;
  char s[80],ss[1024];

    StOpen();
    if (StatFile==0) return 0;

    while (getopt(StatFile,s,ss))
    {   if      (!strcmp(s,"Zoom")) sscanf(ss,"%d",&zoom);
        else if (lcfg(s,ss)) ;
        else if (!strcmp(s,"Pattern")) strcpy(Pattern,ss);
        else if (!strcmp(s,"Macro"))
        {   char *p=ss;
            for (i=0; i<MAXMACRO; i++)
            {   while (*p && *p==' ') p++;
                macro[i]=atoi(p);
                while (*p && *p!=' ') p++;
                if (macro[i]==0) break;
            }
            macro[i]=0;
        }
        else if (strcmp(s,"File")==0) break;
    }
    for (cnt=0; !feof(StatFile) ;cnt++)
    {   if (*s==0) break;
        strcpy(stats[cnt].Name,ss);
        i=0;
        while (getopt(StatFile,s,ss))
        {   if (strcmp(s,"Line")==0) sscanf(ss,"%d",&stats[cnt].Lineno);
            else if (strcmp(s,"Ypos")==0) sscanf(ss,"%d",&stats[cnt].ypos);
            else if (strcmp(s,"Xpos")==0) sscanf(ss,"%d",&stats[cnt].xpos);
            else if (strcmp(s,"Xoffset")==0) sscanf(ss,"%d",&stats[cnt].xoffset);
            else if (strncmp(s,"Mark",4)==0)
            {   sscanf(ss,"%d %d",&stats[cnt].markx[i],&stats[cnt].marky[i]);
                i++;
            }
            else if (strcmp(s,"File")==0) break;
        }
    }

    fclose(StatFile);
    if (cnt==0) return 0;
    for (i=0; i<cnt; i++)
        App->Insert(new EWindow(
            Rect(0,i*SHIGHT/cnt,SWIDTH,(i+1)*SHIGHT/cnt-1),
                stats[i].Name,stats[i].Lineno,
                    stats[i].xpos,stats[i].ypos,stats[i].xoffset,zoom,
                        stats[i].markx,stats[i].marky));
    App->SelectNext();
    check_color();
    if (zoom) App->Handle(t=cmReSize);
    return 1;
} //RestoreStat
