#include "head.h"

int RightMargin=0;
int LeftMargin=0;
unsigned Fmt=0;

extern int wleft (int x, char *str);

void strip (char *S)
{ char *p;
    p=S+strlen(S)-1;
    while (p>S && (*p==' ' || *p=='\t')) *p--=0;
}

void BreakLine (char *S, char *SS, int X)
{       delright(X,S);
        strcpy(SS,tstr);
        strip(SS);
}

int checkquote(char *S, char *SS, char *res)
{ char *p=S;
    *res=0;
    if (*S=='>'||*S=='|'||*S==':')
    {   while (*p=='>'||*p=='|'||*p==':'||*p==' '||*p=='\t') p++;
        if (p-S>10) return 0;
        strncpy(res,S,p-S);
        res[p-S]=0;
        if (strncmp(S,SS,p-S)) return 0;
        p=SS+(p-S);
        while (*p==' '||*p=='\t') p++;
        if (*p=='>'||*p=='|'||*p==':') return 0;
        return 1;
    }
    else
    {   if (*SS==0||*SS=='>'||*SS=='|'||*SS==':'||*SS==' '||*SS=='\t') return 0;
        return 1;
    }
}

void Edit::putl (char *S)
{   modified=1;
    putline(S);
    if (ypos+A.Y<=B.Y)
        sout(0,ypos+A.Y,GetVStr(Cur),0,belong(GetNext(Cur),MarkBlk,Cur,vert));
}

int Edit::Format()
{ char S[MAXSTR+16], SS[MAXSTR+16], temp[MAXSTR+16], quote[12];
  int X0,X1=-1;
  int Y=ypos;
  int Lineno1=Lineno;

    if (!Fmt) return 0;
    if (RightMargin<=0) return 0;
    strcpy(S,strbuf);
    strip(S);
    if (len(S)<=RightMargin) return 0;

    SS[0]=0;

    UndoBuf->put(undo_el(ENDGROUP2,oldx,Lineno,Lines));

again:
        if (len(S)>RightMargin)
        {   X0=len(S);
            while (X0>=RightMargin) X0=wleft(X0,S);
            if (X0>12)
            {   if (ypos==Y) X1=xpos-X0;
                BreakLine(S,SS,X0);
                putl(S);
                strcpy(temp,S);

                strcpy(S,GetVStr(GetNext(Cur)));
                if (!checkquote(temp,S,quote))
                {   strcpy(temp,quote);
                    strcat(temp,SS);
                    if (ypos==Y && xpos>X0)
                    {   if (ypos<(B.Y-A.Y))
                        {   ypos++; Y++;
                            InsLine(temp);
                        }
                        else
                        {   Scr=GetNext(Scr);
                            InsLine(temp,0);
                        }
                        xpos=(X1>0)?X1:0;
                        xoffset=0;
                        if (Lineno>=0) Lineno++;
                        if (Lineno1>=0) Lineno1++;
                    	Lines++;
                    }
                    else
                    {   InsLine(temp);
                        //Cur=GetPrev(Cur);
                    	Lines++;
                    }
		    getline(S);
		    strip(S);
		    goto again;
                }
                else
                {   if (ypos==Y && xpos>X0)
                    {   xpos=(X1>0)?X1:0;
                        xoffset=0;
                        if (Lineno1>=0) Lineno1++;
                        if (ypos<(B.Y-A.Y))
                        {   ypos++; Y++;}
                        else
                        { Scr=GetNext(Scr);
                          scrdn(0);
                        }
                    }
                    else ypos++;
                    if (Lineno>=0) Lineno++;
                    Cur=GetNext(Cur);
                    strcpy(temp,quote);
                    strcat(temp,SS);
                    strcat(temp," ");
                    strcat(temp,S+strlen(quote));
                    putl(temp);
                    getline(S);
                    strip(S);
                    goto again;
                }
            }
        }
    ypos=Y;
    int i;
    for (i=0, Cur=Scr; i<ypos; i++)
        Cur=GetNext(Cur);

    showchanges();
    UndoBuf->put(undo_el(GROUP2,oldx,Lineno,Lines));
    Lineno=Lineno1;
    putflag=0;
    getline(strbuf);
    return 1;
} //Edit::Format
