/*
 *    ()  
 */

#include "head.h"

void Frame::Draw()
{	curxy(A.X,A.Y);
	Color(1);
	Group::Draw();
	Color(0);
} //Frame::Draw

unsigned Frame::Handle (unsigned &c)
{       switch (c)
        { case cmFrameDraw:
                drawed=0;
                break;
          case cmFrame:
                if (Owner->hidden()) drawed=0;
                else if (!drawed)    DrawView();
                break;
          case cmReDraw:
                Rect R=getCoord();
                if ((R.A.Y>=Dirty.A.Y)&&(R.B.Y<=Dirty.B.Y))
                        DrawView();
                break;
        }
        return Group::Handle(c);
} //Frame::Handle

// *** ParamText *** //  
void ParamText::Draw()
{ char *p;
  int x=A.X;
  int y=A.Y;
        if (Get) (*Get)(oldstr,Format,Val);
        else return;
        if (x+strlen(oldstr)>SWIDTH) return;
        curxy(x,y);
        Color(1);
        for (p=oldstr; y<B.Y; )
        {       if ((*p!='\n')&&(x<=B.X))
                {       x++;
                        if (*p) pch(*p);
                        else pch(' ');
                }
                else
                {       y++; x=A.X;
                        curxy(x,y);
                }
                if (*p) p++;
        }
} //ParamText::Draw

void ParamText::ReDraw()
{ char tmp[80];
  int i,j,n;
  int x=A.X;
  int y=A.Y;
        if ((Options&ofHidden)&&!State) return;
        if (!Owner) return;
        if (!Owner->drawed) return;
        if (Get) (*Get)(tmp,Format,Val);
        else return;
        if (x+strlen(tmp)>SWIDTH) return;
        for (i=0; tmp[i]&&oldstr[i]; i++,x++)
                if (tmp[i]!=oldstr[i]) break;
        if (StrCmp(tmp,oldstr)==0)
                return;
        n=StrLen(oldstr);
        strcpy(oldstr,tmp);
        for (j=StrLen(tmp); j<n; j++)
                tmp[j]=' ';
        tmp[j]=0;
        curxy(x,y);
        Color(1);
        for (; tmp[i]&&(y<B.Y); i++)
        {       if (tmp[i]!='\n')
                {       x++;
                        if (x<=B.X) pch(tmp[i]);
                }
                else
                {       y++; x=A.X;
                        curxy(x,y);
                }
        }
} //ParamText::ReDraw

unsigned ParamText::Handle (unsigned &c)
{       switch (c)
        { case cmFrame:
                ReDraw();
          case cmReDraw:
                ReDraw(); break;
        }
        return View::Handle(c);
} //ParamText::Handle

//   
void _Num_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(int*)val); }
void _Num_1 (char *str, char *fmt, void *val)
{ sprintf(str,fmt,(*(int*)val)+1); }
void _Str_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,(char*)val); }
void _Ins_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(int*)val?"Ins":"Ovr"); }
void _Rus_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(int*)val?"RUS":"   "); }
void _Star_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(int*)val?"*":""); }
void _Arrow_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(int*)val?">":""); }

void _Lines_ (char *str, char *fmt, void *val)
{ sprintf(str,fmt,*(long*)val); }
