#ifdef __MSDOS__
#define NOTERMIOS
#endif
#ifndef NOTERMIOS
#include <termios.h>
#endif
#define MAXSTR 1023

#define _F1  0401
#define _F2  0402
#define _F3  0403
#define _F4  0404
#define _F5  0405
#define _F6  0406
#define _F7  0407
#define _F8  0410
#define _F9  0411
#define _F10 0412
#define _F11 0413
#define _F12 0414

#define _ShiftF1  0421
#define _ShiftF2  0422
#define _ShiftF3  0423
#define _ShiftF4  0424
#define _ShiftF5  0425
#define _ShiftF6  0426
#define _ShiftF7  0427
#define _ShiftF8  0430
#define _ShiftF9  0431
#define _ShiftF10 0432
#define _ShiftF11 0433
#define _ShiftF12 0434

#define _AltF1  0441
#define _AltF2  0442
#define _AltF3  0443
#define _AltF4  0444
#define _AltF5  0445
#define _AltF6  0446
#define _AltF7  0447
#define _AltF8  0450
#define _AltF9  0451
#define _AltF10 0452
#define _AltF11 0453
#define _AltF12 0454

#define _Esc   0500
#define _Up    0501
#define _Down  0502
#define _Right 0503
#define _Left  0504
#define _PgUp  0505
#define _PgDn  0506
#define _Home  0507
#define _End   0510
#define _Ins   0511

#define _Del   0177
#define _BS    010
#define _Tab   011
#define _Enter 015
#define _ShiftEnter 012
#define _RusLat 28

#define _wLeft          0600
#define _wRight         0601
#define _delLeft        0602
#define _delRight       0603
#define _delwLeft       0604
#define _delwRight      0605
#define _delLine        0606
#define _ctrlPrefix     0610
#define _Shell          0611
#define _Close          0612
#define _PutLine        0613
#define _AddBuf         0614
#define _CutAddBuf      0615

#define _Top            0620
#define _Bottom         0621
#define _Brackets       0622
#define _SearchNext     0623
#define _SearchRepl     0624
#define _GotoLine       0625
#define _Undo           0626
#define _Config         0627
#define _Zoom           0630
#define _delBlanks      0631
#define _Repeat         0632
#define _Load           0633
#define _Store          0634
#define _def            0635
#define _play           0636
#define _Convert        0637

#define _set0 700
#define _set1 701
#define _set2 702
#define _set3 703
#define _set4 704
#define _set5 705
#define _set6 706
#define _set7 707
#define _set8 708
#define _set9 709

#define _goto0 710
#define _goto1 711
#define _goto2 712
#define _goto3 713
#define _goto4 714
#define _goto5 715
#define _goto6 716
#define _goto7 717
#define _goto8 718
#define _goto9 719

#define _Refresh 01000
#define _Reframe 01001

void kbdmin();
void kbdmax();
extern int getsym();
extern int initty();
void closetty();
void setwait (int m);
extern int ctrl;
struct keydef
{ char *str;
  int link;
  int code;
};
extern struct keydef *syms;
extern struct keydef syms0[];
extern int RUS;
int CtrlBreak();
extern char _CtrlC;
#define MAXMACRO 1024
extern int macro[];
extern int define,play,repeat;
#ifdef NOTERMIOS
extern int speed,minspeed;
#else
extern speed_t speed,minspeed;
#endif
