#include "head.h"

char _CtrlC = '\003';   //    

//  
//  :
//  {" ",   ,}

struct keydef *syms;

struct keydef syms0[]=
{
  {"\033\033",0,_Esc},
  {NULL,0,_F1},
  {NULL,0,_F2},
  {NULL,0,_F3},
  {NULL,0,_F4},
  {NULL,0,_F5},
  {NULL,0,_F6},
  {NULL,0,_F7},
  {NULL,0,_F8},
  {NULL,0,_F9},
  {NULL,0,_F10},

  {NULL,0,_ShiftF1},
  {NULL,0,_ShiftF2},
  {NULL,0,_ShiftF3},
  {NULL,0,_ShiftF4},
  {NULL,0,_ShiftF5},
  {NULL,0,_ShiftF6},
  {NULL,0,_ShiftF7},
  {NULL,0,_ShiftF8},
  {NULL,0,_ShiftF9},
  {NULL,0,_ShiftF10},

  {NULL,0,_AltF1},
  {NULL,0,_AltF2},
  {NULL,0,_AltF3},
  {NULL,0,_AltF4},
  {NULL,0,_AltF5},
  {NULL,0,_AltF6},
  {NULL,0,_AltF7},
  {NULL,0,_AltF8},
  {NULL,0,_AltF9},
  {NULL,0,_AltF10},

  {NULL,0,_Up},           //31
  {NULL,0,_Down},         //32
  {NULL,0,_Right},        //33
  {NULL,0,_Left},         //34
  {NULL,0,_Ins},          //35
  {NULL,0,_Home},         //36
  {NULL,0,_End},          //37
  {NULL,0,_PgUp},         //38
  {NULL,0,_PgDn},         //39

  {NULL,0,_Del},          //40
  {NULL,0,_BS},           //    -  !!!

  {"\0331",0,_F1},
  {"\0332",0,_F2},
  {"\0333",0,_F3},
  {"\0334",0,_F4},
  {"\0335",0,_F5},
  {"\0336",0,_F6},
  {"\0337",0,_F7},
  {"\0338",0,_F8},
  {"\0339",0,_F9},
  {"\0330",0,_F10},

  {"\033u",0,_Up},
  {"\033d",0,_Down},
  {"\033r",0,_Right},
  {"\033l",0,_Left},
  {"\033i",0,_Ins},
  {"\033h",0,_Home},
  {"\033e",0,_End},
  {"\033p",0,_PgUp},
  {"\033n",0,_PgDn},
  {"\033t",0,_Del},

  {"\033[A",0,_Up},
  {"\033[B",0,_Down},
  {"\033[C",0,_Right},
  {"\033[D",0,_Left},

  {"\010",0,_BS},
  {"\011",0,_Tab},
  {"\012",0,_ShiftEnter},
  {"\015",0,_Enter},
  {"\036",0,_Refresh},
  {"\026",0,_ctrlPrefix},
  {"\021",0,_ctrlPrefix},

  {NULL,0,10000},         //   ,    
  {NULL,0,0}
}; //syms0

//  
struct keydef syms1[]=
{
  {"\0130",0,_set0},      //  
  {"\0131",0,_set1},
  {"\0132",0,_set2},
  {"\0133",0,_set3},
  {"\0134",0,_set4},
  {"\0135",0,_set5},
  {"\0136",0,_set6},
  {"\0137",0,_set7},
  {"\0138",0,_set8},
  {"\0139",0,_set9},

  {"\0200",0,_goto0},     //  
  {"\0201",0,_goto1},
  {"\0202",0,_goto2},
  {"\0203",0,_goto3},
  {"\0204",0,_goto4},
  {"\0205",0,_goto5},
  {"\0206",0,_goto6},
  {"\0207",0,_goto7},
  {"\0208",0,_goto8},
  {"\0209",0,_goto9},

  {"\003",0,_Close},            //  
  {"\001",0,_wLeft},            //   
  {"\006",0,_wRight},           //   
  {"\013\025",0,_delLeft},      //    
  {"\013\024",0,_delRight},     //    
  {"\017",0,_delRight},
  {"\013",_BS,_delwLeft},       //   
  {"\013",_Del,_delwRight},     //   
  {"\031",0,_delLine},          //  
  {"\024",0,_Top},              //   
  {"\002",0,_Bottom},           //   

  {"\035",0,_Brackets},         //  
  {"\013\035",0,_Brackets},
  {"\013]",0,_Brackets},

  {"\013r",0,_Load},            //  
  {"\013R",0,_Load},
  {"\013\022",0,_Load},

  {"\013w",0,_Store},           //    
  {"\013W",0,_Store},
  {"\013\027",0,_Store},

  {"\013A",0,_AddBuf},          //   
  {"\013a",0,_AddBuf},
  {"\013\001",0,_AddBuf},
  {"\013",_F5,_AddBuf},

  {"\013",_AltF5,_CutAddBuf},   //     
  {"\013",_ShiftF5,_CutAddBuf},
  {"\013",_F8,_CutAddBuf},
  {"\013",_AltF8,_CutAddBuf},
  {"\013",_ShiftF8,_CutAddBuf},

  {"\013!",0,_Shell},           //   Shell
  {"\013S",0,_Shell},
  {"\013s",0,_Shell},
  {"\013\023",0,_Shell},

  {"\013\013",0,_Convert},      //  <->
  {"\013K",0,_Convert},
  {"\013k",0,_Convert},
  {"\013",0,_Convert},
  {"\013",0,_Convert},

  {"\014",0,_SearchNext},       //  
  {"\005",0,_SearchRepl},       //  &  ()
  {"\007",0,_GotoLine},         //    ...
  {"\025",0,_Undo},             // 
  {"\037",0,_PutLine},          //      

  {"\027",0,_Config},           // 
  {"\032",0,_Zoom},             // zoom
  {"\016",0,_delBlanks},        //   
  {"\022",0,_Repeat},           //  
  {"\004",0,_def},              //  
  {"\030",0,_play},             //  
  {NULL,0,0}
}; //syms1

int conv (char *s);
int LoadKeys(char *name);

int symsize=sizeof(syms0)/sizeof(struct keydef);

void addsym(char *str, int link, int code)
{       syms[symsize-1].str=str;
        syms[symsize-1].link=link;
        syms[symsize-1].code=code;
        symsize++;
        syms=(struct keydef*)realloc(syms,symsize*sizeof(struct keydef));
        syms[symsize-1].str=NULL;
        syms[symsize-1].link=0;
        syms[symsize-1].code=0;
} //addsym

void initkeys()
{       syms=(struct keydef*)malloc(sizeof(syms0));
        memcpy(syms,syms0,sizeof(syms0));
        char path[256];
        gethome(path);
        strcat(path,".ve.key");
        LoadKeys(path);
        LoadKeys(_KEYS_);
        for (int i=0; syms1[i].code ;i++)
                addsym(syms1[i].str,syms1[i].link,syms1[i].code);
} //initkeys

int LoadKeys (char *name)
{ FILE *f;
  char s[80];
  char *p,*pp;
  char key[40], lnk[40], def[40];
  int link,code;

        f=fopen(name,"r");
        if (f==NULL) return 0;

        while (!feof(f))
        {       if (!fgets(s,80,f)) break;
                p=s;
                while (*p && (*p==' ' || *p=='\t' || *p=='\n')) p++;
                if (*p=='#') continue;
                pp=p;
                while (*p && *p!=' ' && *p!='\t' && *p!='\n') p++;
                if (*p==0) continue;
                *p++=0;
                strcpy(key,pp);


                while (*p && (*p==' ' || *p=='\t' || *p=='\n')) p++;
                pp=p;
                while (*p && *p!=' ' && *p!='\t' && *p!='\n') p++;
                if (*p==0) continue;
                *p++=0;
                strcpy(lnk,pp);

                while (*p && (*p==' ' || *p=='\t' || *p=='\n')) p++;
                pp=p;
                while (*p && *p!=' ' && *p!='\t' && *p!='\n') p++;
                *p=0;
                strcpy(def,pp);

                link=conv(lnk);
                code=conv(def);
                if (code==0) continue;
                addsym(strdup(key),link,code);
        }
        fclose(f);
        return 1;
} //LoadKeys

struct keyname
{ char *name;
  int code;
} keynames[]=
{
"F1", _F1,
"F2", _F2,
"F3", _F3,
"F4", _F4,
"F5", _F5,
"F6", _F6,
"F7", _F7,
"F8", _F8,
"F9", _F9,
"F10", _F10,
"F11", _F11,
"F12", _F12,

"ShiftF1",  _ShiftF1,
"ShiftF2",  _ShiftF2,
"ShiftF3",  _ShiftF3,
"ShiftF4",  _ShiftF4,
"ShiftF5",  _ShiftF5,
"ShiftF6",  _ShiftF6,
"ShiftF7",  _ShiftF7,
"ShiftF8",  _ShiftF8,
"ShiftF9",  _ShiftF9,
"ShiftF10", _ShiftF10,
"ShiftF11", _ShiftF11,
"ShiftF12", _ShiftF12,

"AltF1",  _AltF1,
"AltF2",  _AltF2,
"AltF3",  _AltF3,
"AltF4",  _AltF4,
"AltF5",  _AltF5,
"AltF6",  _AltF6,
"AltF7",  _AltF7,
"AltF8",  _AltF8,
"AltF9",  _AltF9,
"AltF10", _AltF10,
"AltF11", _AltF11,
"AltF12", _AltF12,

"Esc",   _Esc,
"Up",    _Up,
"Down",  _Down,
"Right", _Right,
"Left",  _Left,
"PgUp",  _PgUp,
"PgDn",  _PgDn,
"Home",  _Home,
"End",   _End,
"Ins",   _Ins,

"Del",   _Del,
"BS",    _BS,
"Tab",   _Tab,
"Enter", _Enter,
"ShiftEnter", _ShiftEnter,
"RusLat", _RusLat,

"wLeft",  _wLeft,
"wRight", _wRight,
"delLeft",    _delLeft,
"delRight",   _delRight,
"delwLeft",   _delwLeft,
"delwRight",  _delwRight,
"delLine",    _delLine,
"ctrlPrefix", _ctrlPrefix,
"Shell",      _Shell,
"Close",      _Close,
"PutLine",    _PutLine,
"AddBuf",     _AddBuf,
"CutAddBuf",  _CutAddBuf,

"Top",        _Top,
"Bottom",     _Bottom,
"Brackets",   _Brackets,
"SearchNext", _SearchNext,
"SearchRepl", _SearchRepl,
"GotoLine",   _GotoLine,
"Undo",       _Undo,
"Config",     _Config,
"Zoom",       _Zoom,
"delBlanks",  _delBlanks,
"Repeat",     _Repeat,
"Load",       _Load,
"Store",      _Store,
"def",        _def,
"play",       _play,
"Convert",    _Convert,

"set0", _set0,
"set1", _set1,
"set2", _set2,
"set3", _set3,
"set4", _set4,
"set5", _set5,
"set6", _set6,
"set7", _set7,
"set8", _set8,
"set9", _set9,

"goto0", _goto0,
"goto1", _goto1,
"goto2", _goto2,
"goto3", _goto3,
"goto4", _goto4,
"goto5", _goto5,
"goto6", _goto6,
"goto7", _goto7,
"goto8", _goto8,
"goto9", _goto9,

"Refresh", _Refresh
};

int conv (char *s)
{       for (int i=0; i<sizeof(keynames)/sizeof(keyname); i++)
                if (strcmp(s,keynames[i].name)==0)
                        return keynames[i].code;
        return 0;
}

