/*
 *   
 */
#include "head.h"

extern int waiting;
const int FILLER= -1;

//   :
char strbuf[MAXSTR+16]; //   
int iseof=0;            //  ?
int modified=0;         // ,   
int refresh=1;          // ?

//  
int spaces=0;           //  ?
int ins=1;              //  ?

static int posx,posy;

//  
void pc (char c)
{       if (c!=FILLER)
        {    pch(c);
             posx++;
        }
} //pc

//  
void curxy (int x, int y)
{       posx=x;
        posy=y;
        prtc(_curpos,posy,posx);
} //curxy

static int x0,y0;
void savepos()
{ x0=posx; y0=posy; }

void restpos()
{ curxy(x0,y0);}

//  
void Edit::scrup (int y)
{ Rect R=getCoord();
  Color(0);
  if (_scra&&_scrup&&(y<(R.B.Y-R.A.Y)-1))
  {     prtc(_scra,R.A.Y+y,R.B.Y);
        ::curxy(0,R.A.Y+y);
        prtc(_scrup);
        prtc(_scra,0,SHIGHT);
  }
  else if (_dline&&_iline)
  {     ::curxy(0,R.B.Y); dline();
        ::curxy(0,R.A.Y+y); iline();
  }
  else
  {  if (_scrup&&(R.A.Y+y==1)&&(R.B.Y==SHIGHT-1))
     {  ::curxy(0,0);
        clreol();
        prtc(_scrup);
        reframe();
     }
     else drawhalf(y);
  }
} //Edit::scrup

//  
void Edit::scrdn (int y)
{ Rect R=getCoord();
  if (R.A.Y+y>=R.B.Y) return;
  Color(0);
  if (_scra&&_scrdn)
  {     prtc(_scra,R.A.Y+y,R.B.Y);
        ::curxy(0,R.B.Y);
        prtc(_scrdn);
        prtc(_scra,0,SHIGHT);
  }
  else if (_dline&&_iline)
  {     ::curxy(0,R.A.Y+y); dline();
        ::curxy(0,R.B.Y); iline();
  }
  else
  {  if (_scrdn&&(R.A.Y+y==1)&&(R.B.Y==SHIGHT-1))
     {  ::curxy(0,SHIGHT);
        clreol();
        prtc(_scrdn);
        reframe();
     }
     else drawhalf(y);
  }
} //Edit::scrdn

//  . 
void Edit::putspec (char c)
{       Color(2);
        pc(c);
} //putspec

//  . 
void Edit::putctrl (char c)
{       Color(3);
        pc(c);
} //putctrl

//   
void Edit::putnorm (char c)
{       Color(0);
        pc(c);
} //putnorm

void Edit::putinv (char c)
{       Color(5);
        pc(c);
}

//   -
void cpyen (char *str1, int *str2)
{ register int n;
  register unsigned char *p;
  register unsigned *pp;
        for (p=(unsigned char*)str1, pp=(unsigned*)str2, n=0; *p; n++)
        {   if (((*p)==TAB)&&(n%8!=7))
                *pp++ = (unsigned)FILLER;
            else
                *pp++ = *p++;
        }
        for (; n<=MAXSTR; n++)
            *pp++ =0;
} //cpyen

//  -
void cpyel (int *str1, char *str2)
{ register char *pp;
  register int *p;
  register int i;
        for (p=str1, pp=str2, i=0; *p && (i<MAXSTR); p++,i++)
        {   if ((*p)!=FILLER)
                *pp++ = *p;
        }
        *pp++ =0;
        *pp++ =0;
        modified=1;
} //cpyel

static int buf[MAXSTR+16];      //  
char tstr[MAXSTR+16];

//   
int len (char *str)
{ int i;
        cpyen(str,buf);
        for (i=0; buf[i]; i++);
        return i;
} //len

//    
int getpos (char *str, char *p)
{ char c= *p;
        *p=0;
        int l=len(str);
        *p=c;
        return l;
} //getpos

//    
int strpos (int pos, char *str)
{       for (int i=0;;i++)
           if (str[i]==0) return i;
           else if (getpos(str,str+i)>=pos) return i;
}

//     
int getschar (int pos, char *str)
{       cpyen(str,buf);
        return buf[pos];
}

//  
static int fillsp (int x, int *str)
{ int i;
        if (x>=MAXSTR-1) return -1;
        for (i=0; str[i]; i++);
        while (i<x)
            str[i++]=' ';
        return 0;
} //fillsp

//    
static int insert (int c, int x, char *str)
{ int i,l;
        cpyen(str,buf);
        for (l=0; buf[l]; l++);
        if (x>l)
             fillsp(x,buf);
        else l=x;
        if (c!=TAB)
        {   for (i=x-1; buf[i]==FILLER; i--)
            {   buf[i]=' ';
                if (i<l) l=i;
            }
        }
        if (x>=MAXSTR-1) return -1;
        i=MAXSTR-1;
        while (i>=x)
        {   buf[i+1]=buf[i];
            i--;
        }
        buf[x]=c;
        cpyel(buf,str);
        return l;
} //insert

//    
int addstr (char *txt, int x, char *str)
{ int i,l;
        cpyen(str,buf);
        for (l=0; buf[l]; l++); //  
        if (x>l) fillsp(x,buf);
        else     l=x;
        for (i=x-1; (buf[i]==FILLER) && (i>=0); i--)
        {       buf[i]=' ';
                if (i<l) l=i;
        }
        if (x>=MAXSTR-1) return -1;
        for (i=x; txt[i-x] && (i<MAXSTR); i++)
                buf[i] = (unsigned char)txt[i-x];
        cpyel(buf,str);
        return l;
} //addstr

//    
static int over (int c, int x, char *str)
{ int i,l;
        cpyen(str,buf);
        for (l=0; buf[l]; l++);
        if (x>l)
             fillsp(x,buf);
        else l=x;
        if (c!=TAB)
        {   for (i=x-1; buf[i]==FILLER; i--)
            {   buf[i]=' ';
                if (i<l) l=i;
            }
        }
        if (x>=MAXSTR-1) return -1;
        buf[x]=c;
        cpyel(buf,str);
        return l;
} //over

//   
static int erase (int x, char *str)
{ int i;
        cpyen(str,buf);
        if (x>=MAXSTR-1) return -1;
        i=x;
        while (buf[i]==FILLER) i++;
        while (i<MAXSTR-1)
        {   buf[i]=buf[i+1];
            i++;
        }
        buf[MAXSTR]=0;
        for (i=x-1; buf[i]==FILLER; i--)
                buf[i]=' ';
        cpyel(buf,str);
        return 0;
} //erase

int Edit::getUnindent (int x)
{ VStr *p;
  int n;
        for (p=GetPrev(Cur); p; p=GetPrev(p))
        {       n=getLeftSpaces(GetVStr(p));
                if (n<x) return n;
        }
        return 0;
} //Edit::getunindent

int Edit::getLeftSpaces (char *str)
{ int i;
  int buf[MAXSTR+1];
        cpyen(str,buf);
        for (i=0; (buf[i]==FILLER)||(buf[i]==' ')||(buf[i]==TAB); i++);
        return i;
} //Edit::getLeftSpaces

//   
int Edit::bsp (int x, char *str)
{ int i;
        cpyen(str,buf);
        if (x>=MAXSTR-1) return -1;
        if (x<1) return -1;
        if (Unindent&&(getLeftSpaces(str)>=x))  //  -  
                return delcol(getUnindent(x),x,str);

        if (buf[x-1]==FILLER)
        {       for (i=x-1; buf[i]==FILLER; i--);
                for (i++; buf[i]==FILLER; i++) buf[i]=' ';
                if (buf[i]==TAB) buf[i]=' ';
        }
        i=x-1;
        while (i<MAXSTR-1)
        {   buf[i]=buf[i+1];
            i++;
        }
        buf[MAXSTR]=0;
        cpyel(buf,str);
        x--;
        while ((x>0)&&(buf[x-1]==FILLER)) x--;
        return x;
} //bsp

//     
static int getleftpos (int x, char *str)
{       cpyen(str,buf);
        while ((x>0)&&(buf[x-1]==FILLER)) x--;
        return x;
} //getleftpos

//   
int delright (int x, char *str)
{ int i,j;
  static int tbuf[MAXSTR+1];
        cpyen(str,buf);
        --x;
        for (i=x+1,j=0; i<=MAXSTR; i++,j++)
                tbuf[j]=buf[i];         //  
        for (; j<=MAXSTR; j++)
                tbuf[j]=0;
        for (i=x+1; i<=MAXSTR; i++)
                buf[i]=0;
        for (i=x; (i>=0) && (buf[i]==FILLER); i--)
                buf[i]=' ';
        cpyel(buf,str);
        cpyel(tbuf,tstr);
        return x-1;
} //delright

//   
static int delleft (int x, char *str)
{ int i,j;
        cpyen(str,buf);
        while (buf[x]==FILLER) x++;
        if (buf[x]==TAB) x++;
        for (j=0,i=x; i<=MAXSTR; i++,j++)
                buf[j]=buf[i];
        cpyel(buf,str);
        return 0;
} //delleft

//   
int delimiter (char c)
{       switch(c)
        { case FILLER: case TAB: case ' ':
          case ',': case '.': case ':': case ';':
          case '(': case ')': case '[': case ']':
          case '\"': case '\'': case '{': case '}':
          case '/': case '*': case '+': case '-':
          case '=': case '>': case '<': case '?':
          case '!': case '&': case '^': case '~':
          case '@': case 0:
                return 1;
          default:
                return 0;
        }
} //delimiter

static int ConvRusLat (int x, char *str)
{ int i,j,k;
        cpyen(str,buf);
        if (x>0) --x;
        for(i=x; i>0; i--)
            if (!delimiter(buf[i])) break;
        for(; i>0; i--)
            if (delimiter(buf[i]))
            { i++; break; }
        for (j=i; j<=x; j++)
            if ((buf[j]>' ')&&(buf[j]<128))
                buf[j]=(unsigned char)RusMap[buf[j]-' '+64];
            else if (buf[j]>=128)
            {   for (k=64; k<128+64+' '; k++)
                    if ((char)RusMap[k]==(char)buf[j])
                    {   buf[j]=k-64+' ';
                        break;
                    }
            }
        cpyel(buf,str);
        return i;
} //ConvRusLat

// H  
/*static*/ int wleft (int x, char *str)
{ int i;
        cpyen(str,buf);
        if (x>0) --x;
        for(i=x; i>0; i--)
            if (!delimiter(buf[i])) break;
        for(; i>0; i--)
            if (delimiter(buf[i])) return i+1;
        return i;
} //wleft

// H  
static int wright (int x, char *str)
{ int i;
        cpyen(str,buf);
        for(i=x; i<MAXSTR; i++)
            if (delimiter(buf[i])) break;
        for(; i<MAXSTR; i++)
            if (buf[i]==0) break;
            else if (!delimiter(buf[i])) break;
        return i;
} //wright

//   
static int delwleft (int x, char *str)
{ int pos,i,l;
        l=pos=wleft(x,str);
        cpyen(str,buf);
        for (i=x; i<=MAXSTR; i++,pos++)
                buf[pos]=buf[i];
        for (; pos<=MAXSTR; pos++)
                buf[pos]=0;
        cpyel(buf,str);
        return l;
} //delwleft

//   
static int delwright (int x, char *str)
{ int pos=wright(x,str);
        return delcol(x,pos,str);
} //delwright

//   
void getindent (char *str, char *out)
{       while ((*str==' ')||(*str==TAB))
                *out++ = *str++;
        *out=0;
} //getindent

//     beg  fin
int delcol (int beg, int fin, char *str)
{ int i;
        if (beg==fin) return beg;
        if (beg>fin) {int t=fin; fin=beg; beg=t;}
        cpyen(str,buf);
        for (i=beg; i<MAXSTR; i++)  //    . -   !
        {   int c=buf[i];
            if ((c==FILLER)||(c==TAB))
                buf[i]=' ';
            else break;
            if (c==TAB) break;
        }
        for (i=beg-1; buf[i]==FILLER; i--) buf[i]=' ';
        for (i=beg; i<MAXSTR-(fin-beg); i++)
                buf[i]=buf[i+(fin-beg)];
        buf[MAXSTR]=0;
        cpyel(buf,str);
        return beg;
} //delcol

//     beg  fin
int pastecol (int beg, char *str, char *in)
{ int i,l;
        cpyen(str,buf);
        for (i=beg-1; (buf[i]==FILLER)||(buf[i]==0); i--) buf[i]=' ';
        l=StrLen(in);
        for (i=MAXSTR-l; i>=beg; i--)
                buf[i+l]=buf[i];
        for (i=beg; i<beg+l; i++)
                buf[i]=in[i-beg];
        cpyel(buf,str);
        return beg;
} //pastecol

//     beg  fin
int copycol (int beg, int fin, char *str, char *out)
{ int i,pos;
        if (beg>fin) {int t=fin; fin=beg; beg=t;}
        cpyen(str,buf);
        for (i=0,pos=beg; pos<fin; i++,pos++)
                out[i]=buf[pos];
        if ((i>0)&&(out[i-1]==FILLER)) out[i-1]=TAB;
        out[i]=0;
        return beg;
} //copycol

void (Edit::*ps) (char);
void (Edit::*pn) (char);
void (Edit::*pt) (char);

void Edit::setp (int flag)
{       if (flag)
                ps=pt=pn=&Edit::putinv;
        else
        {       ps=&Edit::putspec;
                pt=&Edit::putctrl;
                pn=&Edit::putnorm;
        }
} //setp

//   str   xx
int Edit::sout (int xx, int yy, char *str, int eof, int inv, int maxx)
{ int *p;
  int i,j,pp;
  int size=SWIDTH-xx;
  int offs=xx+xoffset;
  int beg=0,fin=0;

        maxx=maxx-xx+1;
        if (inv&&vert)
        {       beg=Mbeg;
                fin=Mfin;
        }

        curxy(xx,yy);
        if ((xx<=0)&&(offs>0))
        {    setp(inv&&(!vert||(beg<=offs)&&(offs<fin)));
             (this->*ps)('<');  // putspec('<');
             offs++;
             size--;
        }
        cpyen(str,buf);

        beg-=offs; fin-=offs;
        if (beg<0) beg=0;
        if (fin<0) fin=0;
        if (beg>fin) {int t=beg; beg=fin; fin=t;}

        int flag=(offs>0)&&((buf[offs]==FILLER)||(buf[offs]==TAB))
                         &&(buf[offs-1]==FILLER);
        for (p=(buf+offs),i=0; (i<size) && (*p!=0) ; p++)
        {   setp(inv&&(!vert||(beg<=i)&&(i<fin)));
            if (i>maxx) return 0;
            if ((*p==' ') && spaces)
            {   (this->*pt)('.');
                i++;
                flag=0;
            }
            else if (*p==TAB)
            {   pp=((posx+8)&~07)-posx;
                for (j=0; (j<pp) && (i<size); j++,i++)
                {   setp(inv&&(!vert||(beg<=i)&&(i<fin)));
                    if (i>maxx) return 0;
                    if (!spaces)
                         (this->*pn)(' ');
                    else if ((j==0)&&!flag)
                         (this->*pt)('_');
                    else (this->*pt)(' ');
                }
                flag=0;
            }
            else if (*p!=FILLER)
            {   if (*p>=' ')
                     (this->*pn)(*p);
                else (this->*pt)((*p)+0100);
                i++;
                flag=0;
            }
        } //for
        if (*p)
        {       if (p[1]||(*p==TAB)||(*p==FILLER))
                        (this->*ps)('>');
                else if ((*p==' ') && spaces)
                        (this->*pt)('.');
                else if (*p>=' ')
                        (this->*pn)(*p);
                else    (this->*pt)((*p)+0100);
        }
        else
        { char *p="<EOF>";
          int j=i+offs-len(str);
                if (eof&&(j<StrLen(p)))
                    for (p+=j; *p && (i<size); p++,i++)
                    {   setp(inv&&(!vert||(beg<=i)&&(i<fin)));
                        if (i>maxx) return 0;
                        (this->*pt)(*p);
                    }
                for (;(i<fin); i++)
                {   if (i>maxx) return 0;
                    if (inv&&(!vert||(beg<=i)&&(i<fin)))
                         putinv(' ');
                    else putnorm(' ');
                }
                if (inv&&!vert)
                {       Color(5);
                        for (;i<=size; i++) pc(' ');
                }
                else
                {       Color(0);
                        clreol();
                }
        }
        return 0;
} //sout

//   +  
//  (  Edit::Handle)
unsigned Edit::getsym()
{ unsigned c;
  int xx;

        if (view)
        {       frame();
                if (yy>(B.Y-A.Y)) yy= -1;
                if (Edit::xx>(B.X-A.X)) xx= -1;
                if (Edit::xx-xoffset<0||yy<0) ::curxy(SWIDTH-1,SHIGHT);
                else curxy(Edit::xx-xoffset,yy+A.Y);
                return ::getsym();
        }
        int blng=belong(Cur,MarkBlk,Cur,vert);
        getline(strbuf);
        xx=xpos;
        for (;;)
        {  if (modified) changed=1;
           putline(strbuf);
           if (xoffset!=oldxoffs)       //  ?
           {    oldxoffs=xoffset;
                if (vert) Mfin=xpos;
                Draw();                 //   
                xx=0;
                refresh=0;
           }
           else if (vert&&(Mfin!=xpos))
           {    Mfin=xpos;
                int beg=calcy(Cur);
                int fin=calcy(MarkBlk);
                if (beg>fin) {int t=fin; fin=beg; beg=t;}
                Rect R=getCoord();
                int xmin=(xx>xpos)?xpos:xx;
                int xmax=(xx<xpos)?xpos:xx;
                xmin-=xoffset; xmax-=xoffset;
                Dirty.Assign(R.A.X+xmin,R.A.Y+beg,R.A.X+xmax,R.A.Y+fin);
                ReDraw();
           }

           if (vert) Mfin=xpos;

           if (xpos<xx) xx=xpos;
           if (xx<0) xx=0;

           if (refresh)
           {    if (xx-xoffset<0) xx=xoffset;
                sout(xx-xoffset,ypos+A.Y,strbuf,iseof,blng);
           }
           xx=xpos;
           cpyen(strbuf,buf);
           Curchar=buf[xpos];
           if (Curchar==(unsigned)FILLER) Curchar=TAB;
           //frame();
           curxy(xpos-xoffset,ypos+A.Y);
           refresh=0;
           oldx=xpos; oldy=ypos;

           c=View::getsym();    //    
           if (ctrl)
           {    refresh=1;
                if (c==_Tab)
                {   xx=insert(c,xpos,strbuf);
                    xpos+=8; xpos&=~007;
                    if (xpos-xoffset>=SWIDTH)
                       xoffset+=8;
                }
                else if (c<0xFF)
                {   if (ins)
                         xx=insert(c,xpos,strbuf);
                    else xx=over(c,xpos,strbuf);
                    if (xpos<MAXSTR-1)
                        xpos++;
                    if (xpos-xoffset>=SWIDTH)
                        xoffset+=8;
                }
                else return c;
           }
           else
           switch (c)
           { case _Ins:
                ins=!ins;
                break;
             case _Left:
                if (xpos>0)
                {   xpos--;
                    if (!ThruTabs)
                        while ((xpos>0)&&(buf[xpos-1]==FILLER))
                            xpos--;
                }
                if ((xpos<=xoffset)&&(xoffset>0))
                    xoffset-=8;
                break;
             case _Right:
                if (xpos<MAXSTR-1)
                {   xpos++;
                    if (!ThruTabs)
                        while ((xpos<MAXSTR-1)&&(buf[xpos-1]==FILLER))
                            xpos++;
                }
                if (xpos-xoffset>=SWIDTH)
                    xoffset+=8;
                break;
             case _Home:
                xpos=0;
                xoffset=0;
                break;
             case _End:
                xpos=len(strbuf);
                while (xpos-xoffset>=SWIDTH)
                        xoffset+=8;
                while (xpos-xoffset<0)
                        xoffset-=8;
                break;
             case _wLeft:
                xpos=wleft(xpos,strbuf);
                while ((xpos<=xoffset)&&(xoffset>0))
                   xoffset-=8;
                break;
             case _wRight:
                xpos=wright(xpos,strbuf);
                while (xpos-xoffset>=SWIDTH)
                   xoffset+=8;
                break;
             case _Del:
                if (xpos>=len(strbuf)) return _Del;
                xx=getleftpos(xpos,strbuf);
                erase(xpos,strbuf);
                refresh=1;
                putflag=0;
                break;
             case _BS:
                if (xpos==0) return _BS;
                xx=getleftpos(xpos-1,strbuf);
                xpos=bsp(xpos,strbuf);
                refresh=1;
                if ((xpos<=xoffset)&&(xoffset>0))
                    xoffset-=8;
                putflag=0;
                break;
             case _delRight:
                if (xpos>=len(strbuf)) return _delBlanks;
                xx=delright(xpos,strbuf);
                refresh=1;
                putflag=0;
                break;
             case _delLeft:
                xx=delleft(xpos,strbuf);
                xpos=0; xoffset=0;
                refresh=1;
                putflag=0;
                break;
             case _delwLeft:
                xpos=delwleft(xpos,strbuf);
                xx=0;
                while ((xpos<=xoffset)&&(xoffset>0))
                   xoffset-=8;
                refresh=1;
                putflag=0;
                break;
             case _delwRight:
             case _delBlanks:
                if (xpos>=len(strbuf)) return _delBlanks;
                xpos=delwright(xpos,strbuf);
                xx=0;
                while (xpos-xoffset>=SWIDTH)
                   xoffset+=8;
                refresh=1;
                putflag=0;
                break;
             case _Convert:
                xpos=ConvRusLat(xpos,strbuf);
                while ((xpos<=xoffset)&&(xoffset>0))
                   xoffset-=8;
                refresh=1;
                putflag=0;
                break;
             case _ctrlPrefix:
                ctrl=1;
                continue;
             default:
                if (c==_Tab)
                {   if (((xpos+8)&~007)>=(MAXSTR-1)) break;
                    xx=insert(c,xpos,strbuf);
                    xpos+=8; xpos&=~007;
                    if (xpos-xoffset>=SWIDTH)
                       xoffset+=8;
                    refresh=1;
                    putflag=0;
                    if (Format()) return 0;
                }
                else if ((' '<=c) && (c<0xFF))
                {   if (ins)
                         xx=insert(c,xpos,strbuf);
                    else xx=over(c,xpos,strbuf);
                    if (xpos<MAXSTR-1)
                        xpos++;
                    if (xpos-xoffset>=SWIDTH)
                        xoffset+=8;
                    refresh=1;
                    putflag=0;
                    if (Format()) return 0;
                }
                else return c;
                break;
           } // switch
           ctrl=0;
           if (!trig)
                vert=1;
           trig=1;
        } //forever
} //editline
