/*
 *     ve
 */

#include "head.h"
#include <setjmp.h>

#ifdef __MSDOS__
#include <io.h>
unsigned _stklen = 10000;
#else
#include <unistd.h>
#endif

extern void gettermcap();
extern void initkeys();
extern char *basekeys[];
extern char *viewkeys[];
extern int reading;
extern jmp_buf jump;
extern Group *Running;
extern char Names[];

Group *App;
KeyBar *Key;

unsigned view=0;
unsigned hlp=0;
unsigned rest=0;
unsigned noclear=0;
unsigned fast=0;
unsigned color=1;

char *title;

// -  
class Application:public Group
{ public:
        Application ():Group(Rect(0,0,0,0))
        {       gettermcap();
                initkeys();
                initty();
                Assign(0,0,SWIDTH,SHIGHT);
                App=this;
        };
        
	virtual void DrawView()
	{	//        
		char str[80];
		Names[0]=0;
		unsigned t;
		Handle(t=cmGetName);
		sprintf(str,title,Names);
		xtitle(str);
		Group::DrawView();
	};
        
        ~Application()
        {       if (drawed)
                {       Color(0);
                        if (!noclear) clrscr();
                        else
                        { ::curxy(0,SHIGHT);
                          clreol();
                        }
                }
                closetty();
        };
};

static void HelpScr()
{       fprintf(stderr,"  (C) Text editor by Yu.I.Finkel (yura@mv.ru)\r\n");
        fprintf(stderr,"      v 3.12 (3.03.99)\r\n");
        fprintf(stderr,"  Use: ve [-vcbiwudfrh] [+num] file ...\r\n");
        fprintf(stderr,"           -v    view\r\n");
        fprintf(stderr,"           -c[-] use color display\r\n");
        fprintf(stderr,"           -b[-] create .b files\r\n");
        fprintf(stderr,"           -i[-] autoindent\r\n");
        fprintf(stderr,"           -w[-] word wrap (format)\r\n");
        fprintf(stderr,"           -u[-] backspace unindents\r\n");
        fprintf(stderr,"           -t[-] cursor through tabs\r\n");
        fprintf(stderr,"           -d[-] save desktop\r\n");
        fprintf(stderr,"           -n    don't clear screen\r\n");
        fprintf(stderr,"           -f    fast edit: don't create temp file\r\n");
        fprintf(stderr,"           -r    restore (default if no args)\r\n");
        fprintf(stderr,"           -h    this help\r\n");
        exit(0);
} //HelpScr

struct { char ch;
         unsigned int *val;
       } switches[]=
{ {'v',&view},    {'b',&Bak},
  {'i',&AutoIndent},  {'u',&Unindent},
  {'t',&ThruTabs},{'d',&Save},
  {'h',&hlp},     {'?',&hlp},
  {'r',&rest},    {'n',&noclear},
  {'f',&fast},    {'w',&Fmt},
  {'c',&color},
  {0,NULL} };

unsigned mystd;
int getargs (int argc, char *argv[], int lin[], char *p[])
{ int cnt,n;
    mystd=0;
    for (cnt=0,n=1; n<argc; n++)
    {   if (argv[n][0]=='-')
        {   if (!mystd&&(argv[n][1]==0))
            {   p[cnt++]="";
                mystd++;
            }
        }
        else if (argv[n][0]=='+')
                lin[cnt]=atoi(argv[n]+1);
        else    p[cnt++]=argv[n];
    }
    return cnt;
} //getargs

void getswitches (int argc, char *argv[])
{ int n,i;
    for (n=1; n<argc; n++)
    {   char *pp=argv[n];
        if (*pp++=='-')
        {   if (*pp)
                for (; *pp; pp++)
                   for (i=0; switches[i].ch; i++)
                      if (switches[i].ch==tolower(*pp))
                      {   if (pp[1]=='-')
                                *(switches[i].val)=0;
                          else  *(switches[i].val)=1;
                      }
        }
    }
    if (strstr(argv[0],"view"))
    { view=1; Save=0;
    }
} //getswitches

void makeswap()
{       char *name;
        if (Swap!=NULL) return;
#ifdef __MSDOS__
        char path[256];
        gethome(path);
        if ((name=tempnam(path,"swap")) == NULL) return;
        if ((Swap=fopen(name,"w+"))!=NULL) strcpy(SwapName,name);
        free(name);
#else
        /*if ((name=tempnam(_TMP1_,"swap"))==NULL)
          if ((name=tempnam(_TMP2_,"swap"))==NULL) return;*/
	tmpnam(SwapName);
        if ((Swap=fopen(SwapName,"w+"))!=NULL); //strcpy(SwapName,name);
#endif
} //makeswap

void winch (int s)
{ unsigned t;
#ifdef SIGWINCH
        signal(SIGWINCH, &winch);
#else
#ifdef SIGWIND
        signal(SIGWIND, &winch);
#endif
#endif
        App->Handle(t=_Refresh);
        if (reading) longjmp(jump,1);
}

void init_signals ()
{
#ifdef SIGWINCH
        signal(SIGWINCH, &winch);
#else
#ifdef SIGWIND
        signal(SIGWIND, &winch);
#endif
#endif
}

int main(int argc, char **argv)
{
  static int lin[12];
  static char *p[12];
  int cnt,i;


        if (!isatty(fileno(stdout)))
        {       fprintf(stderr,"stdout is not a tty!\r\n");
                return 0;
        }
        loadcfg();
        cnt=getargs(argc,argv,lin,p);
        getswitches(argc,argv);
        if (mystd&&isatty(fileno(stdin)))
        {       fprintf(stderr,"stdin is not a file!\r\n");
                return 0;
        }

        if (hlp) HelpScr();

	Application myApp;

        if (view)
                Key=new KeyBar(Rect(0,SHIGHT,SWIDTH,SHIGHT+1),viewkeys);
        else    Key=new KeyBar(Rect(0,SHIGHT,SWIDTH,SHIGHT+1),basekeys);
        App->Insert(Key);

        if (!view) makeswap();

        if ((cnt==0)||rest)
        {   if (!RestoreStat()) HelpScr();
        }
        else
        {   StOpen();
            for (i=0; i<cnt; i++)
            {   EWindow *pp=new EWindow(
                        Rect(0,i*SHIGHT/cnt,SWIDTH,(i+1)*SHIGHT/cnt-1),
                        p[i],lin[i]);
                if (pp->status>=0)
                        App->Insert(pp);
                else    delete pp;
            }
            App->SelectNext();
        }
        getswitches(argc,argv);
        init_signals ();
        if (wcnt)
	{	initscr();
		title=getenv("VE_TITLE");
		if (title==NULL) title="";
		Color(7);
		clrscr();
		App->Exec();
		title=getenv("VE_TITLE_AFTER");
		if (title==NULL) title="";
		xtitle(title);
		resetscr();
        }
        if (SwapName[0]) remove(SwapName);
        return 0;

} //main
